<?php
/*
Plugin Name: Possibly Related Recent Posts
Plugin URI: http://sivel.net/wordpress/
Description: Automatically displays possibly related posts at the end of each post using a filter on the_content.  List generated on the fly by recency and the categories the current post is in.  Does NOT use tags.
Author: Matt Martz
Author URI: http://sivel.net/
Version: 1.1

        Copyright (c) 2008 Matt Martz (http://sivel.net)
        Possibly Related Recent Posts is released under the GNU General Public License (GPL)
        http://www.gnu.org/licenses/gpl-2.0.txt
*/

function related_posts ( $related_content ) {
	if ( ! is_page () ) :
		global $post;
		$p = $post;
		$categories = '';
		foreach ( ( get_the_category () ) as $category ) :
			$categories .= $categories . ',' . $category->cat_ID ;
		endforeach;
		$related = '<p><strong>Possibly Related Posts:</strong></p>' . "\r\n";
		$related .= '<ul>' . "\r\n";
		foreach ( ( get_posts ( 'numberposts=5&category=' . $categories . '&orderby=date&exclude=' . $post->ID ) ) as $post ) :
			 $related_links .= '<li><a href="' . get_permalink($post->ID) . '">' . get_the_title($post->ID) . '</a></li>' . "\r\n";
		endforeach;
		if ( isset ( $related_links ) )
			$related .= $related_links;
		else
			$related .= '<li>None found</li>' . "\r\n";
		$related .= '</ul><br />' . "\r\n";
		$related_content = $related_content . "\r\n" . $related;
	endif;
	$post = $p;
	return $related_content;
}

add_filter ( 'the_content' , 'related_posts' );
?>
